import java.util.NoSuchElementException;
class ListElem {

    /* The value of this elem. */       
    private Object value;
    /* The tail of the list. */
    private ListElem tail;
        
    ListElem(Object value, ListElem tail) {
        this.value = value;
        this.tail = tail;
    }
    ListElem(Object value) {
        this(value, null);
    }

    ListElem getTail() {
        return tail;
    }
    Object get(int index) throws NoSuchElementException {
        if (index == 0) {
            return value;
        }
        else if (tail == null) {
            throw new NoSuchElementException();
        }
        else {
            return tail.get(index - 1);
        }
    }
    Object getValue() {
        return value;
    }
    void setTail(ListElem elem) {
        tail = elem;
    }
    void setValue(Object object) {
        value = object;
    }
    ListElem findLastElem() {
        ListElem result = this;
        while (result.tail != null)
            result = result.tail;
        return result;

    }
}
